"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPluginOptionsGetter = void 0;
var lodash_1 = require("lodash");
exports.createPluginOptionsGetter = function (mergeWith, defaultOptions) { return function (options) {
    var pluginOptions = mergeWith(options);
    if (lodash_1.isPlainObject(pluginOptions)) {
        return lodash_1.merge({}, lodash_1.isPlainObject(defaultOptions) ? defaultOptions : {}, pluginOptions);
    }
    if (lodash_1.isPlainObject(defaultOptions)) {
        return defaultOptions;
    }
}; };
function createPluginCreator(target, enable, options) {
    if (enable === void 0) { enable = true; }
    return function (opt) {
        var didEnabled = enable;
        if (lodash_1.isFunction(enable)) {
            didEnabled = enable(opt);
        }
        if (!didEnabled) {
            return;
        }
        var plugin = [target];
        var pluginOptions = options;
        if (lodash_1.isFunction(options)) {
            pluginOptions = options(opt);
        }
        if (lodash_1.isPlainObject(pluginOptions)) {
            plugin.push(pluginOptions);
        }
        else if (lodash_1.isPlainObject(didEnabled)) {
            plugin.push(didEnabled);
        }
        return plugin;
    };
}
exports.default = createPluginCreator;
