"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPluginOrPresetDeclaration = exports.isPluginOrPresetTarget = exports.isDevelopment = exports.isTest = exports.isProduction = void 0;
var lodash_1 = require("lodash");
exports.isProduction = function (env) { return env === 'production'; };
exports.isTest = function (env) { return env === 'test'; };
exports.isDevelopment = function (env) { return (!exports.isProduction(env) &&
    !exports.isTest(env)); };
exports.isPluginOrPresetTarget = function (value) { return (lodash_1.isString(value) ||
    lodash_1.isObject(value)); };
exports.isPluginOrPresetDeclaration = function (value) {
    if (exports.isPluginOrPresetTarget(value)) {
        return true;
    }
    if (Array.isArray(value)) {
        var target = value[0], options = value[1];
        return (exports.isPluginOrPresetTarget(target) &&
            (lodash_1.isUndefined(options) ||
                lodash_1.isPlainObject(options)));
    }
    return false;
};
